namespace Vanilla.Core.Extensions
{

	public static class FloatRangeExtensions
	{
		
		// ---------------------------------------------------------------------------------------------- Validation //

		// Inclusive
		
		public static bool IsWithinInclusiveRange(this FloatRange input,
		                                          float           value) => value >= input.min && value <= input.max;

		// Exclusive

		public static bool IsWithinExclusiveRange(this FloatRange input,
		                                          float           value) => value > input.min && value < input.max;
		
	}

}